<?php
/**
 *
 */
class ErrorHandler extends CErrorHandler
{
    /**
     * @var array store error pages for different error types
     * i.e
     * array(
     *       'e404'=> array(
     *           'en' => 'site/404en'
     *       )
     * )
     * Error key should starts with 'e'
     */
    public $errorPages = array();

    public function init()
    {
        parent::init();

        register_shutdown_function(array($this, 'handleFatalError'));
    }

    public function getErrorDisplayPage()
    {
        if ($this->error) {
            $code = 'e' . $this->error['code'];
            if (array_key_exists($code, $this->errorPages)) {
                if (array_key_exists(Yii::app()->language, $this->errorPages[$code])) {
                    return $this->errorPages[$code][Yii::app()->language];
                } else {
                    $tmp = array_values($this->errorPages[$code]);
                    return array_shift($tmp);
                }
            }
        }

        return false;
    }

    public function handleFatalError()
    {
        $error = error_get_last();
        if (isset($error) && in_array($error['type'], array(E_ERROR, E_PARSE, E_COMPILE_ERROR, E_CORE_ERROR))) {
            $message = "{$error['message']}. File: {$error['file']}. Line: {$error['line']}";
            Yii::log($message, CLogger::LEVEL_ERROR, 'php');
            Yii::app()->log->processLogs(new CEvent());
        }
    }

}
