<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * Class for helping in work with headers
 */
class HeadersHelper
{

    /**
     * Build content headers for file content.
     *
     * @param string $path    file path
     * @param string $content file content
     *
     * @return array headers
     */
    public static function forFile($path, $content = null)
    {
        $headers = array();
        $headers[] = "Content-Type: " . CFileHelper::getMimeTypeByExtension($path);
        if ($content) {
            $headers[] = "Content-Length: " . mb_strlen($content);
        }
        return $headers;
    }

    /**
     * Build cache headers for file
     *
     * @param int $seconds seconds to cache
     *
     * @return array headers
     */
    public static function cache($seconds)
    {
        $headers = array();
        $headers[] = "Pragma: public";
        $headers[] = "Expires: " . date("r", time() + $seconds);
        $headers[] = "Cache-Control: public";

        return $headers;
    }
}
