<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 */
class m120330_130431_custom_user_fields extends CDbMigration
{
    public function safeUp()
    {
        $this->createTable('{{profiles_fields}}', array(
            'id' => 'pk',
            'varname' => 'string NOT NULL',
            'title' => 'string NOT NULL',
            'field_type' => 'string NOT NULL',
            'field_size' => "integer NOT NULL DEFAULT '0'",
            'field_size_min' => "integer NOT NULL DEFAULT '0'",
            'required' => "integer NOT NULL DEFAULT '0'",
            'match' => "string DEFAULT NULL",
            'range' => "string NOT NULL DEFAULT ''",
            'error_message' => "string NOT NULL DEFAULT ''",
            'other_validator' => "text NOT NULL DEFAULT ''",
            'default' => "string NOT NULL DEFAULT ''",
            'widget' => "string NOT NULL DEFAULT ''",
            'widgetparams' => "text NOT NULL DEFAULT ''",
            'position' => "integer NOT NULL DEFAULT '0'",
            'visible' => "integer NOT NULL DEFAULT '0'",
        ));
        $this->createIndex('profiles_fields_varname_idx', '{{profiles_fields}}', 'varname');
        $this->createIndex('profiles_fields_widget_idx', '{{profiles_fields}}', 'widget');
        $this->createIndex('profiles_fields_visible_idx', '{{profiles_fields}}', 'visible');

        $this->insert('{{profiles_fields}}', array('varname' => 'lastname', 'title' => 'Last Name', 'field_type' => 'VARCHAR', 'field_size' => 255, 'field_size_min' => 3, 'required' => 1, 'error_message' => 'Incorrect Last Name (length between 3 and 255 characters).', 'position' => 1, 'visible' => 3,));
        $this->insert('{{profiles_fields}}', array('varname' => 'firstname', 'title' => 'First Name', 'field_type' => 'VARCHAR', 'field_size' => 255, 'field_size_min' => 3, 'required' => 1, 'error_message' => 'Incorrect First Name (length between 3 and 255 characters).', 'position' => 3, 'visible' => 3,));
        $this->insert('{{profiles_fields}}', array('varname' => 'birthday', 'title' => 'Birthday', 'field_type' => 'DATE', 'field_size' => 0, 'field_size_min' => 0, 'required' => 2, 'widget' => 'UWjuidate', 'widgetparams' => '{"ui-theme":"base","defaultDate":"-20y","maxDate":"+0y","minDate":"-100y","yearRange":"-100:+0","changeMonth":"true","changeYear":"true"}', 'position' => 3, 'visible' => 2,));
        $this->insert('{{profiles_fields}}', array('varname' => 'title', 'title' => 'Title', 'field_type' => 'VARCHAR', 'field_size' => '30', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'gender', 'title' => 'Gender', 'field_type' => 'VARCHAR', 'field_size' => '1', 'field_size_min' => '1', 'required' => '2', 'range' => 'M==Male;F==Female', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'photo', 'title' => 'Photo', 'field_type' => 'VARCHAR', 'field_size' => '255', 'field_size_min' => '0', 'required' => '0', 'other_validator' => '{\"file\":{\"types\":\"jpg, gif, png\",\"allowEmpty\":\"true\"}}', 'widget' => 'UWfile', 'widgetparams' => '{\'path\':\'assets\'}', 'position' => '100', 'visible' => '0'));
        $this->insert('{{profiles_fields}}', array('varname' => 'private_zip', 'title' => 'Private Zip', 'field_type' => 'VARCHAR', 'field_size' => '64', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'private_city', 'title' => 'Private City ', 'field_type' => 'VARCHAR', 'field_size' => '50', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'private_country', 'title' => 'Private Country', 'field_type' => 'VARCHAR', 'field_size' => '50', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'private_phone_number', 'title' => 'Private Phone Number', 'field_type' => 'VARCHAR', 'field_size' => '100', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'private_mobile_phone', 'title' => 'Private Mobile Phone Number ', 'field_type' => 'VARCHAR', 'field_size' => '100', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'company', 'title' => 'Company', 'field_type' => 'VARCHAR', 'field_size' => '100', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'position', 'title' => 'Position', 'field_type' => 'VARCHAR', 'field_size' => '100', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'business_zip', 'title' => 'Business ZIP ', 'field_type' => 'VARCHAR', 'field_size' => '64', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'business_city', 'title' => 'Business City', 'field_type' => 'VARCHAR', 'field_size' => '50', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'business_country', 'title' => 'Business Country', 'field_type' => 'VARCHAR', 'field_size' => '50', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'business_phone_number', 'title' => 'Business Phone Number ', 'field_type' => 'VARCHAR', 'field_size' => '100', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'business_mobile_phone_number', 'title' => 'Business Mobile Phone Number', 'field_type' => 'VARCHAR', 'field_size' => '100', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'skypename', 'title' => 'Skypename', 'field_type' => 'VARCHAR', 'field_size' => '50', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'icq_number', 'title' => 'ICQ-Number', 'field_type' => 'VARCHAR', 'field_size' => '32', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'facebook_profile', 'title' => 'Facebook Profile', 'field_type' => 'VARCHAR', 'field_size' => '255', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'xing_profile', 'title' => 'Xing Profile', 'field_type' => 'VARCHAR', 'field_size' => '255', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'linkedin_profile', 'title' => 'LinkedIn Profile', 'field_type' => 'VARCHAR', 'field_size' => '255', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'twitter_name', 'title' => 'Twitter-Name', 'field_type' => 'VARCHAR', 'field_size' => '50', 'field_size_min' => '0', 'required' => '2', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'make_public', 'title' => 'Make my profile public', 'field_type' => 'VARCHAR', 'field_size' => '1', 'field_size_min' => '0', 'required' => '2', 'range' => 'checkbox-1', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'find_me_in_phone_book', 'title' => 'Find me in phone book', 'field_type' => 'VARCHAR', 'field_size' => '1', 'field_size_min' => '0', 'required' => '2', 'range' => 'checkbox-1', 'position' => '100', 'visible' => '3'));
        $this->insert('{{profiles_fields}}', array('varname' => 'send_me_notifications', 'title' => 'Send me notifications via mail', 'field_type' => 'VARCHAR', 'field_size' => '1', 'field_size_min' => '0', 'required' => '2', 'range' => 'checkbox-1', 'position' => '100', 'visible' => '3', 'default' => 1));


        $this->addColumn("{{profiles}}", "title", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "gender", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "photo", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "private_zip", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "private_city", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "private_country", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "private_phone_number", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "private_mobile_phone", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "company", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "position", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "business_zip", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "business_country", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "business_phone_number", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "business_mobile_phone_number", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "skypename", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "icq_number", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "facebook_profile", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "xing_profile", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "linkedin_profile", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "twitter_name", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "make_public", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "business_city", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "find_me_in_phone_book", "string NOT NULL DEFAULT ''");
        $this->addColumn("{{profiles}}", "send_me_notifications", "string NOT NULL DEFAULT '1'");
    }

    public function safeDown()
    {
        $this->dropTable('{{profiles_fields}}');

        $this->dropColumn("{{profiles}}", "title");
        $this->dropColumn("{{profiles}}", "gender");
        $this->dropColumn("{{profiles}}", "photo");
        $this->dropColumn("{{profiles}}", "private_zip");
        $this->dropColumn("{{profiles}}", "private_city");
        $this->dropColumn("{{profiles}}", "private_country");
        $this->dropColumn("{{profiles}}", "private_phone_number");
        $this->dropColumn("{{profiles}}", "private_mobile_phone");
        $this->dropColumn("{{profiles}}", "company");
        $this->dropColumn("{{profiles}}", "position");
        $this->dropColumn("{{profiles}}", "business_zip");
        $this->dropColumn("{{profiles}}", "business_country");
        $this->dropColumn("{{profiles}}", "business_phone_number");
        $this->dropColumn("{{profiles}}", "business_mobile_phone_number");
        $this->dropColumn("{{profiles}}", "skypename");
        $this->dropColumn("{{profiles}}", "icq_number");
        $this->dropColumn("{{profiles}}", "facebook_profile");
        $this->dropColumn("{{profiles}}", "xing_profile");
        $this->dropColumn("{{profiles}}", "linkedin_profile");
        $this->dropColumn("{{profiles}}", "twitter_name");
        $this->dropColumn("{{profiles}}", "make_public");
        $this->dropColumn("{{profiles}}", "business_city", "");
        $this->dropColumn("{{profiles}}", "find_me_in_phone_book");
        $this->dropColumn("{{profiles}}", "send_me_notifications");

        return true;
    }

    /*
     // Use safeUp/safeDown to do migration with transaction
     public function safeUp()
     {
     }
 
     public function safeDown()
     {
     }
     */
}