<?php
/**
* module for cms user authentication
*/
class CmsuserauthenticationModule extends CWebModule
{
    public $authUrl = '';
    public $salt_secretkey = '';
    public $username_sessionattr = '';
    public $cmsBackendUrl = '';

        /**
        * starts the authentication request
        */
    public function startRequest(){
         $username = '';
         $password = '';

         if(isset(Yii::app()->user->{$this->username_sessionattr})){
                $username = Yii::app()->user->{$this->username_sessionattr};
         }
         $password = md5($this->salt_secretkey.$username);
         YII::app()->session->add('feSid', $this->sendRequest($username, $password));
    }
    /**
    * print out the path to backend cms with sid and encrypted cookie data
    */
    public function printBackendPath(){
        include_once 'encryption_class.php';
        echo $this->cmsBackendUrl.'?sid='.YII::app()->session->get('feSid').'&value='.$this->encrypt($_COOKIE["GCN_SESSION_SECRET"]);
    }
	
   /**
     * sends a POST request to the GCN Rest API login service (http://www.gentics.com/Content.Node/guides/restapi/resource_AuthenticationResource.html#path__auth_login.html)
     * sets the SessionSecret Cookie for the Client
     * returns a valid CMS User Session
     */
    private function sendRequest($username, $password){
        $url =$this->authUrl;
        $data = json_encode(array("login"=>$username, "password"=>$password));

                if(!in_array  ('curl', get_loaded_extensions())){
                Yii::log('Error: curl not installed','trace','exception.CDbException');
                echo '<script language = "JavaScript" type = "text/JavaScript">alert("Error: curl not installed");</script>';
                return;
        }
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_HEADER, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array("Content-Type: application/json; charset=utf-8"));
        curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.13) Gecko/20080311 Firefox/2.0.0.13');

        $response = curl_exec($curl);
        $info = curl_getinfo($curl);
        $header = substr($response, 0, $info['header_size']);
        $headers = ($this->http_parse_headers($header));
        $body = substr($response, $info['header_size'], strlen($response)-1);
        $body = json_decode($body);
	curl_close($curl);
        if(isset($headers["Set-Cookie"])){
                $cookie = $headers["Set-Cookie"];
                $key = substr($cookie, 0 , strpos($cookie,'='));
                $value = substr($cookie, strpos($cookie,'=')+1, strlen($cookie)-1);
                $value = str_replace("; Path=/", "", $value);
                setcookie($key, $value,time()+60*60*24, '/');
                //setcookie ($key, $value,time()+60*60*24, '/',$this->cmsBackendDomain);
                //return $body['sid'];
                return $body->{'sid'};
        }
        else{
                Yii::log('Error: Authentication on CMS failed','trace','exception.CDbException');
                echo '';
                return;
        }
    }



    /**
     * http_parse_headers function from pecl documentation
     * 
     */
    private function http_parse_headers( $header ){
        $retVal = array();
        $fields = explode("\r\n", preg_replace('/\x0D\x0A[\x09\x20]+/', ' ', $header));
        foreach( $fields as $field ) {
            if( preg_match('/([^:]+): (.+)/m', $field, $match) ) {
                $match[1] = preg_replace('/(?<=^|[\x09\x20\x2D])./e', 'strtoupper("\0")', strtolower(trim($match[1])));
                if( isset($retVal[$match[1]]) ) {
                    $retVal[$match[1]] = array($retVal[$match[1]], $match[2]);
                } else {
                    $retVal[$match[1]] = trim($match[2]);
                }
            }
        }
        return $retVal;
    }
    /*
     * encrypt data with secret Key
     */
    private function encrypt($val){
        $key = "secretKey123#";
        $crypt = new encryption_class();
        $min_length = 8;
        $encrypt_result = $crypt->encrypt($key, $val, $min_length);
        return urlencode($encrypt_result);
    }
}
?>