<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * This controller used for widgets preview.
 * It returns widgets with some content.
 */
class PreviewController extends BaseController
{

    /**
     * CommentsWidget
     *
     * @param string      $contentId      content id
     * @param bool|string $allowAnonymous allow anonymous comments
     *
     * @return void
     */
    public function actionCommentsWidget($contentId = null, $allowAnonymous = 'true')
    {
        $this->renderPartial('CommentsWidget', array('contentId' => $contentId, 'allowAnonymous' => strtolower($allowAnonymous) === 'true'));
    }

    /**
     * CommentsFormWidget
     *
     * @param string $contentId      content id
     * @param bool   $allowAnonymous allow anonymous comments
     *
     * @return void
     */
    public function actionCommentsFormWidget($contentId = null, $allowAnonymous = true)
    {
        $this->renderPartial('CommentsFormWidget', array('contentId' => $contentId, 'allowAnonymous' => strtolower($allowAnonymous) === 'true'));
    }

    /**
     * CommentsListWidget
     *
     * @param string $contentId content id
     *
     * @return void
     */
    public function actionCommentsListWidget($contentId = null)
    {
        $this->renderPartial('CommentsListWidget', array('contentId' => $contentId));
    }

}
