(function($) {
	
	$.fg.Form = {
		
			object: null,
		
		init: function()
		{
			var bp = $.fg.Config.basePath;
			// thirdparty libs
			$.include( bp+"/assets/js/jquery/tipsy/jquery.tipsy.js" );
			$.include( bp+"/assets/js/jquery/tipsy/css/tipsy.css" );
			
			this.object = $( "#fg-form" );
			
			this.object.find( "form" ).submit( $.proxy( this.onSubmitHandler, this ) );
		},
		
		callServerAction: function(actionName, options)
		{
			options = $.extend( {
					type: "POST",
					dataType: "json"
				},
				options || {}
			);
			var actionUrl = $.String.sub( $.fg.Config.serverFormActionsUrl, {action: actionName} );
			$.ajax( actionUrl, options );
		},
		
		getRowByElementName: function(name)
		{
			return this.object.find( "form :input[name="+ name +"]" ).closest( ".row" );
		},
	
		onSubmitHandler: function(e)
		{
			e.preventDefault();
			
			$.fg.Form.callServerAction( "submit", {
				data: this.object.find( "form" ).serialize(),
				success: $.proxy( this.validateCallback, this )
			} );
			
			return false;
		},
		
		validateCallback: function(data)
		{
			this.object.find( ".row" ).removeClass( "error" );
			this.object.find( ".row .errorMessage" ).remove();
			if(data.status == false) {
				$.each( data.errors, $.proxy( function(name, messages) {
					var row = this.getRowByElementName( name );
					if(row) {
						row.addClass( "error" );
						var error = $( "<div>", {text: messages.join( "<br />" )} ).addClass( "errorMessage" );
						row.append( error );
					}
				}, this ) );
			} else {
				//this.object.find( "form" ).unbind( "submit").submit();
				window.location.href = data.redirectUrl;
			}
		}

	};
	
	$( $.proxy( $.fg.Form.init, $.fg.Form ) );
	
})(jQuery);