<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 */

    if (!$this->isBreadcrumb || $lvl==1) {
?>
    <ul class="<?php echo $this->cssClass; ?> lvl<?php echo $lvl; ?>">
<?php
    }

    foreach ($branch as $item) {
        if ($this->isBreadcrumb && !(in_array($item['contentid'], $this->activePath))){
            continue;
        }
        ?>
        <li>
            <?php
                $name = !empty($item['attributes']['name_'.$this->lang]) ? $item['attributes']['name_'.$this->lang] : $item['attributes']['name'];
                $url = isset($item['attributes']['startpageurl_'.$this->lang]) ? $item['attributes']['startpageurl_'.$this->lang] : (isset($item['attributes']['startpageurl']) ? $item['attributes']['startpageurl'] : '');

                $hasChildrenClass = !empty($item['children']) ? 'has-children' : '';
                if (strpos($url, 'http') === false) {
                    if (in_array($item['contentid'], $this->activePath)) {
                        echo CHtml::link($name, Yii::app()->createUrl($url), array('class'=>'active '.$hasChildrenClass));
                    } else {
                        echo CHtml::link($name, Yii::app()->createUrl($url), array('class'=>$hasChildrenClass));
                    }
                } else {
                    echo CHtml::link($name, $url, array('class'=>$hasChildrenClass));
                }

                /* if current node has children and children's lvl does not go out of maxLvl - then show it */
                if (isset($item['children']) && (in_array($item['contentid'], $this->activePath) || $this->isSitemap) && ($this->maxLvl == 0 || $lvl < $this->maxLvl)) {
                    $this->render('_branch', array('branch'=>$item['children'], 'lvl'=>($lvl+1)));
                }
            ?>
        </li>
        <?php
    }
    if (!$this->isBreadcrumb || $lvl==1) {
?>
</ul>
<?php
    }
?>