<?php
/**
 *
 */
class PdfHelper
{

    public static function grabCssToSingleFile($html, $folder, $expirationTime = 3600)
    {
        $css = self::findCss($html);
        if (!empty($css)) {
            $cssContentFile = $folder . '/' . md5(serialize($css)) . '.css';
            if (!file_exists($cssContentFile) || time() - filemtime($cssContentFile) > $expirationTime) {
                $cssContent = '';
                foreach ($css as $cssUrl) {
                    $content = self::downloadCss($cssUrl);
                    $cssContent .= $content;
                }
                file_put_contents($cssContentFile, $cssContent);
            }
            return $cssContentFile;
        } else {
            return false;
        }
    }

    public static function findCss($html)
    {
        $css = array();
        preg_match_all('/(<link.*\/>)/', $html, $links);
        if (!empty($links[0])) {
            foreach ($links[0] as $l) {
                preg_match_all('/\s+(?<name>.*?)=(?<value>".*?")/', $l, $rawAttributes);
                $attributes = array();
                for ($i = 0; $i < count($rawAttributes['name']); $i++) {
                    $attributes[$rawAttributes['name'][$i]] = trim($rawAttributes['value'][$i], ' "');
                }
                if (isset($attributes['rel'], $attributes['href']) && $attributes['rel'] == 'stylesheet') {
                    $css[] = $attributes['href'];
                }
            }
        }
        return $css;
    }

    private static function downloadCss($file)
    {
        if (!preg_match('/^(http|https):/', $file)) {
            $file = Yii::app()->createAbsoluteUrl($file);
        }
        return file_get_contents($file);
    }

}
