<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * Navigation module class file.
 */
class PersonalizedContentModule extends CWebModule
{
    /**
     * @var int the number of seconds in which the cached value will expire. 0 means never expire.
     */
    public $cacheTime = 60;

    /**
     * @var array that contains list of URLs that should not be shown in navigation trees
     */
    public $excludeURLs = array();

    /**
     * @var string GCC request params. Comma separated.
     */
    public $gccRequestParams;

    /**
     * @var integer how many results show per page
     */
    public $perPage;

    /**
     * @var string $sorting contains sorting expression
     */
    public $sorting;
    /**
     * @var whether to use arrows instead of words next, previous in the paging
     */
    public $enableArrowsInPaging = true;
    /**
     * Import dependent classes
     *
     * @return void
     */
    public function init()
    {
        // import the module-level components
        $this->setImport(
            array(
                'personalizedContent.components.*',
            )
        );
    }

    /**
     * Translates a message to the specified language.
     *
     * @param string $str    message
     * @param array  $params params
     * @param string $dic    dictionary
     *
     * @return string
     */
    public static function t($str = '', $params = array(), $dic = 'core')
    {
        return Yii::t("personalizedContentModule." . $dic, $str, $params);
    }
}
