<?php
/**
 *
 */
class AccessRule extends CAccessRule
{
    /**
     * Checks if user is matched
     *
     * @param IWebUser $user the user
     *
     * @return boolean whether the rule applies to the user
     */
    protected function isUserMatched($user)
    {
        if (empty($this->users)) {
            return true;
        }
        foreach ($this->users as $u) {
            if ($u==='*') {
                return true;
            } else if ($u==='?' && $user->getIsGuest()) {
                return true;
            } else if ($u==='@' && !$user->getIsGuest()) {
                return true;
            } else if (!strcasecmp($u, $user->getEmail())) {
                return true;
            }
        }
        return false;
    }
}
