<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * Widget for view items in users cart
 */
class ItemListWidget extends BaseJuiWidget
{
    /**
     * @var string the title which shows above item list
     */
    public $title;
    /**
     * @var integer id of the customer
     */
    public $user_id;
    /**
     * @var integer number of displayed items
     */
    public $count;
    /**
     * @var string name of css class of unsorted list
     */
    public $class;
    /**
     * @var string link to the shoppingcart page
     */
    public $shoppingcart_link;
    /**
     * @var boolean boolean the flag which determines when item names are references
     */
    public $link_items_to_page;
    /**
     * Override base init. For skipping scripts and css init.
     *
     * @return void
     */
    public function init()
    {
        Yii::app()->user->setState('shoppingcart_link',$this->shoppingcart_link);
    }

    /**
     * Render ItemListWidget view
     *
     * @return void
     */
    public function run()
    {
        $order_id = Order::getOrder(true);

        $model = Item::model()->findAll(array('condition'=>'order_id=:order_id','limit'=>$this->count,'params'=>array(':order_id'=>$order_id)));

        $this->render('ItemListWidget', array('model'=>$model));
    }
}
