<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 */
?>

<?php echo CHtml::beginForm(); ?>

<table width="100%" cellspacing="0" cellpadding="0" class="items">
    <colgroup>
        <col width="10%">
        <col width="65%">
        <col width="10%">
        <col width="10%">
        <col width="5%">
    </colgroup>
    <tr>
        <th class="item_quantity"><?php echo Item::model()->getAttributeLabel('quantity'); ?></th>
        <th class="item_title"><?php echo Item::model()->getAttributeLabel('title'); ?></th>
        <th class="item_price"><?php echo Item::model()->getAttributeLabel('price'); ?></th>
        <th class="item_sum"><?php echo ShoppingcartModule::t('Total'); ?></th>
        <th></th>
    </tr>
    <?php
    $sum = 0;
    foreach($this->items as $i=>$item):
        $sum += $item->price * $item->quantity;
    ?>
    <tr>
        <td class="item_quantity">
            <?php
            echo CHtml::activeTextField($item,"[{$i}]quantity",array('class'=>'quantity positiveNumbersOnly', 'maxlength'=>3));
            ?>
        </td>
        <td class="item_title">

            <?php
            if($this->link_items_to_page){

                echo CHtml::link($item->title,
                ($item->item_referrer)?$item->item_referrer: $item->referrer,
                array('class'=>'metanavlink all-items-link'));

            }else{
                echo $item->title;
            }

            ?>
        </td>
        <td class="item_price"><?php echo ($item->price != 0)?Item::addCurrency($item->price):ShoppingcartModule::t('free'); ?></td>
        <td class="item_sum"><?php echo ($item->price != 0)?Item::addCurrency(($item->price * $item->quantity)):ShoppingcartModule::t('free'); ?></td>
        <td class="item_del"><div class="cross">
        <?php
            echo CHtml::Link('X', Yii::app()->createUrl('shoppingcart/item/remove',array('id'=>$item->id)),array('class'=>'metanavlink'));
        ?>
        </div></td>
    </tr>
    <?php endforeach; ?>
    <tfoot>
    <td colspan="3" class="total_title"><?php echo ShoppingcartModule::t('Total'); ?></td>
    <td class="item_sum"><?php echo Item::addCurrency($sum); ?></td>
    <td></td>
    </tfoot>
</table>

<input type="hidden" name="step" value="<?php echo $this->step ?>">

<div class="row controls">
    <?php echo CHtml::submitButton(ShoppingcartModule::t('Next')); ?>
</div>

<?php echo CHtml::endForm(); ?>
