<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 */
?>

<?php $form = $this->beginWidget('CActiveForm', array(
    'id'=>'tmp-user-form',
    'enableAjaxValidation'=>true,
    'focus'=>array($this->user,'title')
)); ?>

<p class="note">
    <?php echo ShoppingcartModule::t('Fields with {required} are required.',array('{required}'=>"<span class='required''>*</span>")); ?>
</p>

<?php echo $form->errorSummary($this->user); ?>

<?php
foreach ($this->user->attributes as $fieldName => $fieldValue): ?>
<?php $hidden = array("id","user_id","parent_user_id");
    if(in_array($fieldName,$hidden)){continue;} ?>

<?php if($this->user->metadata->tableSchema->columns[$fieldName]->dbType != "date"): ?>

    <div class="row">
        <?php echo $form->labelEx($this->user,$fieldName); ?>
        <?php echo $form->textField($this->user,$fieldName); ?>
        <?php echo $form->error($this->user,$fieldName); ?>
    </div>

    <?php else: ?>

    <div class="row">
        <?php echo $form->labelEx($this->user,$fieldName); ?>
        <?php
        $format = Yii::app()->locale->getDateFormat();

        $this->widget('shoppingcart.components.CJuiDatePicker',array(
            'name'=>'publishDate',
            'model'=> $this->user,
            'id'=> "TmpUser_$fieldName",
            'attribute'=>'birthday',
            'language'=> LocaleHelper::yiiLocaleToJq(Yii::app()->getLanguage()),
            'i18nScriptFile' => 'jquery.ui.datepicker-ja.js',
            // additional javascript options for the date picker plugin
            'options'=>array(
                //'dateFormat' => $format,
                'showOn'=>'focus',
                'yearRange'=> (date('Y')-100).':'.(date('Y')-18),
                'defaultDate'=>'-40y',
                'changeMonth'=>true,
                'changeYear'=>true,
                'buttonText'=>'',
                'dateFormat' => LocaleHelper::yiiFormatToJq($format),
            ),
            'htmlOptions'=>array(
                'style'=>'height:20px;'
            ),
        ));
        ?>
        <?php echo $form->error($this->user,$fieldName); ?>
    </div>

    <?php endif; ?>

<?php endforeach; ?>

<input type="hidden" name="step" value="<?php echo $this->step ?>">

<div class="row controls">
    <?php echo CHtml::submitButton(ShoppingcartModule::t('Next')); ?>
</div>

<?php $this->endWidget(); ?>