<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 *
 */
class UpdatesModule extends CWebModule
{
    public $currentVersion;

    /**
     * Model initial method
     *
     * @return void
     */
    public function init()
    {
        $this->setImport(
            array(
                'updates.components.*',
                'updates.models.*'
            )
        );
    }


    /**
     * Translates a message to the specified language.
     *
     * @param string $str    message
     * @param array  $params params
     * @param string $dic    dictionary
     *
     * @return string
     */
    public static function t($str = '', $params = array(), $dic = 'language')
    {
        return Yii::t("UpdatesModule." . $dic, $str, $params);
    }

    private $_assetsUrl;

    /**
     * Returns path for assets
     *
     * @return string
     */
    public function getAssetsUrl()
    {
        if (!$this->_assetsUrl) {
            $this->_assetsUrl = Yii::app()->assetManager->publish(Yii::getPathOfAlias('updates.views.asset'), true);
        }
        return $this->_assetsUrl;
    }
}
