<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 *
 */

/**
 * Facebook provider class.
 * @package application.extensions.eauth.services
 */
class FacebookService extends FacebookOAuthService  implements IUserFields
{
    protected function fetchAttributes() {
        $info = (object) $this->makeSignedRequest('https://graph.facebook.com/me');

        $this->attributes['id'] = $info->id;
        $this->attributes['name'] = $info->first_name.'_'.$info->last_name;
        $this->attributes['url'] = $info->link;
        $this->attributes['email'] = $info->email;

        $this->attributes['firstname'] = $info->first_name;
        $this->attributes['lastname'] = $info->last_name;
        $this->attributes['gender'] = $info->gender == 'male' ? 'M' : 'F';
    }

    public function getName()
    {
        return $this->attributes['name'];
    }

    public function getEmail()
    {
        return $this->attributes['email'];
    }

    public function getError()
    {
        return UserModule::t('Facebook authorization error');
    }
}