<?php

class UserProfileEditWidget extends BaseUserWidget
{
    /**
     * Shows a particular model.
     *
     * @return void
     */
    public function run()
    {
        if(Yii::app()->request->getParam('approveEmail', false)){
            $email = Yii::app()->request->getParam('approveEmail');
            $key   = Yii::app()->request->getParam('key');
            if (!User::model()->exists("email=:email", array('email' => $email))) {
                $user = User::model()->findByAttributes(array('activkey' => $key));
                if ($user) {
                    $user->email = $email;
                    if ($user->save()) {
                        Yii::app()->user->setFlash('approveState', UserModule::t("Email {email} was succesfully approved.", array('{email}'=>$email)));
                    }
                }
            }else{
                Yii::app()->user->setFlash('approveState', UserModule::t("Email {email} was not approved. Maybe it already exists.", array('{email}'=>$email)));
            }
        }

        if (Yii::app()->user->id) {
            $User = RegistrationForm::model()->findByPk(Yii::app()->user->id);
            $Profile = $User->profile;
            foreach (array('User', 'Profile') as $modelName) {
                if (($modelData = Yii::app()->user->getState($modelName)) != null) {
                    ${$modelName}->attributes = $modelData['attributes'];
                    foreach ($modelData['errors'] as $attribute => $errors) {
                        foreach ($errors as $e) {
                            ${$modelName}->addError($attribute, $e);
                        }
                    }
                    Yii::app()->user->setState($modelName, null);
                }
            }

            $this->render('UserProfileEditWidget', array('model' => $User, 'profile' => $Profile));
        }
    }
}