<?php

/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * Represents single question
 *
 **/
class Question extends CActiveRecord
{

    /**
     * Returns the static model of the specified AR class.
     *
     * @param string $className active record class name
     *
     * @return array|CActiveRecord
     */
    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    /**
     * Returns the name of the associated database table.
     * By default this method returns the class name as the table name.
     * You may override this method if the table is not named after this convention.
     *
     * @return string the table name
     */
    public function tableName()
    {
        return '{{question}}';
    }

    /**
     * Returns the validation rules for attributes.
     *
     * @return array
     */
    public function rules()
    {
        return array(
            array('created', 'default', 'value' => AppHelper::mysqlDate()),
            array('id, author_id, text','required'),
            array('id', 'length', 'max'=>255),
            array('author_id', 'numerical', 'integerOnly' => true),
            array('text', 'safe'),
            array('created', 'type', 'type'=>'datetime', 'datetimeFormat' => 'yyyy-MM-dd HH:mm:ss'),
            array('id, author_id, text, created','safe', 'on'=>'search'),
        );
    }


    public function getAttributeLabel($name)
    {
        return VoteModule::t(parent::getAttributeLabel($name));
    }

    public function relations()
    {
        return array(
            'answers' => array(CActiveRecord::HAS_MANY, 'Answer', 'question_id')
        );
    }
} 
