

<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 *
 */
$client_config = array(
    //The configuration of the currently installed modules (module ID => configuration).
    //detail config is in /modules folder
    // languagecode,name,node_id,sortorder,permissions,navhidden,url,title,entry_media,teaser,creationdate,creator,tagging,hideinoverview
    'modules' => array(
        //personalized content module
        'personalizedContent' => array(
            //Component class
            'class' => 'common.modules.personalizedContent.PersonalizedContentModule',
            //  cache life time in seconds
            'cacheTime' => 60,
            //  excludeURLs - URL's that should not be shown in navigation widgets like ''(empty) or '#' or '/', etc.
            'excludeURLs' => array('', '/', '#'),
            // GCC request params. Comma separated. Example: name,name_en.
            //Do not include personalisation attributes here, they will be added automatically.
            //updatetimestamp will also be added - because it is required
            'gccRequestParams' => 'languagecode,name,node_id,sortorder,permissions,navhidden,url,title,entry_media,teaser,creationdate,creator,tagging,hideinoverview',
            'perPage' => 5,
        ),

        //yii-user module
        'user' => array(
            'authField' => 'email',
            // define startpages for portal
            'homePageUrl' => array(
                'en' => '/Content.Node/index.html',
                'de' => '/Content.Node/index.de.html'
            ),
	    // needed for changing email in edit profile
	    'profileEditUrl' => array(
		'en' => '/Content.Node/service/UserProfileEditWidget.en.html',
		'de' => '/Content.Node/service/UserProfileEditWidget.de.html',
	    ),
	    // admin email for registration approval
	    'registrationNotifyAdminEmail'=>'km.schremser@gentics.com',
	    'registrationNotifyAdminTemplate'=>'notifyAdminAboutRegister',
	    
	    'sendActivationMail' => true,
	    // should the user be activated after registration
	    'activeAfterRegister' => true,
        ),
        'comments' => array(
            'cacheTime' => 30
        ),
	'fg' => array(
                'class' => 'common.modules.fg.FgModule',
                'clientBasePath' => 'http://cms.gportal-dev.gentics.com/formgenerator',
            // editor client server local path
            'clientLocalPath' => '/Node/var/httpd/htdocs/formgenerator',
            'proxyPath' => '',
            'notificationsEmail' => 'gportal.formgenerator@gentics.com',
            'defaultLogin' => array(
                    'username' => 'dummyuser@gentics.com', 
                    'password' => 'dummy'
            ),
            'thankYouPage' => "/danke.html"

        ),
	// cms user authentication module
        'cmsuserauthentication' => array(
            'class' => 'common.modules.cmsuserauthentication.CmsuserauthenticationModule',
            'authUrl' => 'http://'.$_SERVER['HTTP_HOST'].'/gcnproxy/CNPortletapp/rest/auth/login',
            'salt_secretkey' => 'SecretSalt1234#',
            'username_sessionattr' => 'email',
            'cmsBackendUrl' => 'http://cms.gportal-dev.gentics.com/backend.php'
        ),
        'contentSource' => array(
            //Current content renderer class
            //Allowed values:
            // - DynamicContentSource
            // - FileSystemContentSource
            'sourceClass' => 'DynamicContentSource',
            //Content repository settings
            'sourceSettings' => array(
                //Dynamic Content Renderer settings
                'DynamicContentSource' => array(
                    //folder into which content will be cached
                    'cacheFolder' => '/var/www/gPortal/DCR',
                    //If use personalization for current content source
                    'usePersonalisation' => true,
                    //Array of fields which will be additionally request from Gentics Content Connector
                    //and used in personalisation checking algorithm
                    'personalisationFields' => array('permissions')
                ),
                //File System Content Renderer settings
                'FileSystemContentSource' => array(
                    //folder which contained File System Content Renderer content
                    'contentFolder' => '/var/www/gPortal/DCR',
                    //If use personalization for current content source
                    'usePersonalisation' => true,
                    //Array of fields which will be additionally request from Gentics Content Connector
                    //and used in personalisation checking algorithm
                    'personalisationFields' => array('permissions')
                ),
            ),
            'homePage' => 'Content.Node/index.html',
            //the number of seconds in which the cached value will expire. 0 means never expire.
            //used for caching content personalisation attributes and modification time
            'cacheTime' => 60 
        ),
        //tagcloud module
        'tagcloud' => array(
            //Component class
            'class' => 'common.modules.tagcloud.tagcloudModule',
            //  cache life time in seconds
            'cacheTime' => 60,
            //default CMS page with personalizedOverview widget
            'defaultOverviewPage' => '/Content.Node/testing/Overview.en.html',
            //CMS pages with personalizedOverview widget per language
            'overviewPages' => array(
                'en' => '/Content.Node/testing/Overview.en.html',
                'de' => '/Content.Node/testing/Overview.de.html',
            ),
            //String that will be used as tags separator
            'tagsSeparator' => ', ',
            //tagstyles. Array of styles for tags. Controls weights gradations and styles.
            // So if 3 gradations defined - tags would be separated into 3 categories
            //must be defined from most light(rare) to most heavy(frequent)
            'tagstyles' => array(
                'tagsize_1',    //ex.: 10px
                'tagsize_2',    //ex.: 14px
                'tagsize_3',    //ex.: 16px
            )
        ),
        'language' => array(
            //array of used languages
            'languages' => array(
                'en' => 'en',
                'de' => 'de'
            )
        ),
    ),

    //The application components (indexed by their IDs).
    //detail config is in /components folder
    'components' => array(
        'repositoryApi' => array(
            'url' => 'http://localhost:8080',
	    'failover_urls' => array(
		'http://gportal-devsssss-fscr-frontend.gentics.com:8080',
		'http://10.0.1.9:8080'
	    ),
            'additionalRequestParameters' => array(                
		'contentRepositorySearch' => array(
                    'filter' => 'object.node_id=="4"',
                ),
                'binaryContent' => array(
                    'filter' => 'object.node_id=="4"'
                ),
                'search' => array(
                    'filter' => 'node_id:4'
                )
            )
        ),
        'messages' => array(
            //If true try to use dictionary files from custom section
            'customI18n' => true,
        ),
        //Component for Yii::app()->user {@link RWebUser}
        'user' => array(
        ),
        //Component manager of database connections
        'db' => array(
            'connectionString' => 'mysql:host=localhost;dbname=gportal', // 'connectionString' => 'mysql:host=localhost:42006;dbname=gportal',
            'tablePrefix' => 'gportal_',
            //DB username
            'username' => 'root',
            //DB Password
            'password' => 'smw99', // no pw
            //number of seconds that table metadata can remain valid in cache. 86400, 0 - disabled
            'schemaCachingDuration' => 30,
            //slave connection config is same as CDbConnection
            'slaves' => array(
                'slave1' => array(
                    'connectionString' => 'mysql:host=slave1;dbname=xxx',
                    'username' => 'root',
                    'password' => '********'
                ),
            ),
        ),
        //Cache settings
        'cache' => array(
            'servers' => array(
                'server1' => array('host' => '127.0.0.1', 'port' => 11211, 'weight' => 60),
            ),
        ),
        'eauth' => array(
            //Component class
            'class' => 'common.extensions.eauth.EAuth',
            // Use the popup window instead of redirecting.
            'popup' => true,
            //currenly using services for authentication /var/www/gportalapp
            'services' => array(
                'standard' => array(
                    'title' => 'With username/password'
                ),
                'google' => array(
                    'class' => 'site.common.modules.user.services.GoogleService',
                    'title' => 'Google open Id'
                ),
                'facebook' => array(
                    // application register at: https://developers.facebook.com/apps/
                    'title' => 'Facebook',
                    'class' => 'site.common.modules.user.services.FacebookService',
                    'client_id' => '310892639000191', //'330781883695574'
                    'client_secret' => '0bb580b40a8244a111d600e9088ecdb8', // 'ee246ffcf9e54b99cd6b92357b160009'
                    'scope' => 'email'
                ),
            )
        ),
        //
        'errorHandler' => array(
            'errorPages' => array(
                'e400' => array(
                    'en' => '/site/error400',
                ),
                'e403' => array(
                    'en' => '/site/error403',
                ),
                'e404' => array(
                    'en' => '/Content.Node/error/404.en.html',
                    'de' => '/Content.Node/error/404.de.html'
                )
            )
        )
    ),
);

if ( isset( $_GET['cssjs'] ) ) {

if ( $_GET['cssjs'] == 'combinedcssonly' )
	{
	$client_config['components']['clientScript'] = array(
            'disableRegisterFiles' => true,
            //combine css files to single file
            'combineCss' => true,
            //compress css files
            'compressCombinedCss' => false,
//            //combine js files to single file
            'combineJs' => false,
//            //compress js files
            'compressCombinedJs' => false
        );
	}

if ( $_GET['cssjs'] == 'combinedandcompressedcss' )
        {
        $client_config['components']['clientScript'] = array(
            'disableRegisterFiles' => true,
            //combine css files to single file
            'combineCss' => true,
            //compress css files
            'compressCombinedCss' => true,
//            //combine js files to single file
            'combineJs' => false,
//            //compress js files
            'compressCombinedJs' => false
        );
        }

if ( $_GET['cssjs'] == 'combinedonly' )
        {
        $client_config['components']['clientScript'] = array(
            'disableRegisterFiles' => true,
            //combine css files to single file
            'combineCss' => true,
            //compress css files
            'compressCombinedCss' => true,
//            //combine js files to single file
            'combineJs' => true,
//            //compress js files
            'compressCombinedJs' => false
        );
        }

if ( $_GET['cssjs'] == 'combinedandcompressed' )
        {
        $client_config['components']['clientScript'] = array(
            'disableRegisterFiles' => true,
            //combine css files to single file
            'combineCss' => true,
            //compress css files
            'compressCombinedCss' => true,
//            //combine js files to single file
            'combineJs' => true,
//            //compress js files
            'compressCombinedJs' => true
        );
        }

}
if ( $_SERVER['HTTP_HOST'] == 'portaldemo.gentics.com' ) {
	$client_config['components']['db'] = array (           
	    'connectionString' => 'mysql:host=localhost:42006;dbname=gportal',
            'tablePrefix' => 'gportal_',
            //DB username
            'username' => 'root',
            //DB Password
            'password' => '', // no pw
            //number of seconds that table metadata can remain valid in cache. 86400, 0 - disabled
            'schemaCachingDuration' => 300,
            //slave connection config is same as CDbConnection
            'slaves' => array(
            ),
        );
	$client_config['components']['eauth'] = array(
            //Component class
            'class' => 'common.extensions.eauth.EAuth',
            // Use the popup window instead of redirecting.
            'popup' => true,
            //currenly using services for authentication /var/www/gportalapp
            'services' => array(
                'standard' => array(
                    'title' => 'With username/password'
                ),
                'google' => array(
                    'class' => 'site.common.modules.user.services.GoogleService',
                    'title' => 'Google open Id'
                ),
                'facebook' => array(
                    // application register at: https://developers.facebook.com/apps/
                    'title' => 'Facebook',
                    'class' => 'site.common.modules.user.services.FacebookService',
                    'client_id' => '330781883695574',
                    'client_secret' => 'ee246ffcf9e54b99cd6b92357b160009',
                    'scope' => 'email'
                )
            )
        );

}
return $client_config;

