<?php
/**
 *
 */

define('CLIENT_CONFIG_LOCATION', '../custom/runtime/client_main.php');

$settings = array();

require '../framework/yii.php';
require '../framework/db/CDbConnection.php';

$ClientMainConfiguration = include '../custom/config/client_main.php';

/* This should be done by the shell-installer
$dirs = array('/common/runtime', '/custom/runtime', '/tests/runtime', '/frontend/runtime', '/frontend/www/assets');
$notWritable = array();
foreach ($dirs as $d) {
    $rd = realpath('../' . $d);
    if (is_writable($rd)) {
        continue;
    } else {
        $notWritable[] = $rd;
    }
}
if (!empty($notWritable)) {
    write('Below directories should be writable');
    write(implode($notWritable, "\n"));
    if (prompt('Change directory access?')) {
        foreach ($notWritable as $d) {
            if (@chmod($d, 755)) {
                write("$d now is writable");
            } else {
                write('You don`t have access for changing folder access mode. Run script as root');
            }
        }
    }
}
*/

$settings['components']['db'] = array();

if (prompt('Do you use a database?')) {
    sql:
    do {
        $n = ask("What database:\n1) MySQL \n2) Postgres \n3) Oracle");
    } while (!in_array($n, array(1, 2, 3)));
    $host = ask('Host (i.e. localhost):');
    $port = ask('Port (i.e. 3306, you can also leave it blank):');
    $database = ask('Database name:');
    $settings['components']['db']['username'] = ask('Username:');
    $settings['components']['db']['password'] = ask('Password:');
    switch ($n) {
        case 1:
            $settings['components']['db']['connectionString'] = "mysql:host=$host" . ($port ? ":$port" : '') . ";dbname=$database";
            break;
        case 2:
            $settings['components']['db']['connectionString'] = "pgsql:host=$host;" . ($port ? "port=$port;" : '') . "dbname=$database";
            break;
        case 3:
            $settings['components']['db']['connectionString'] = "oci:dbname=$host" . ($port ? ":$port" : '') . "/$database;charset=UTF8";
            break;
    }
    $connection = new CDbConnection($settings['components']['db']['connectionString'], $settings['components']['db']['username'], $settings['components']['db']['password']);
    try {
        $connection->setActive(true);
        write('Connection success!');
    } catch (Exception $e) {
        write($e->getMessage());
        if (yes(ask('Try again?'))) {
            goto sql;
        } else {
            write("You can configure it manually. In client_main.php set 'db' component settings. ");
            ask('');
        }
    }
}

//contentSource
if (prompt('Will you use Dynamic Content Renderer (DCR) (recommended) (you must have a Gentics Content Connector running)?')) {
    $sett = &$settings['modules']['contentSource']['sourceSettings']['DynamicContentSource'];
    $sett['cacheFolder'] = ask('Location of your cache folder (i.e. /var/www/DCR/), must be writeable for webserver-user:');
    $sett['usePersonalisation'] = false;
    $sett['personalisationFields'] = array();
    if (prompt('Will you use personalisation?')) {
        $sett['usePersonalisation'] = true;
        $personalisationFields = ask('Enter personalisation attributes (multivalue) requested by Gentics Content Connector - must be defined in CMS (Tagmap) (i.e. permissions):');
        $sett['personalisationFields'] = array_map('trim', explode(',', $personalisationFields));
    }
    $settings['modules']['contentSource']['sourceClass'] = 'DynamicContentSource';
}

if (prompt('Will you use File System Content Renderer (FSCR) alternatively?')) {
    $sett = &$settings['modules']['contentSource']['sourceSettings']['FileSystemContentSource'];
    $sett['contentFolder'] = ask('Location of your published CMS files (i.e. /var/www/FSCR/):');
    $sett['usePersonalisation'] = false;
    $sett['personalisationFields'] = array();
    if (prompt('Will you use personalisation?')) {
        $sett['usePersonalisation'] = true;
        $personalisationFields = ask('Enter personalisation attributes (multivalue) requested by Gentics Content Connector - must be defined in CMS (Tagmap) (i.e. permissions):');
        if (!empty($personalisationFields)) {
            $sett['personalisationFields'] = array_map('trim', explode(',', $personalisationFields));
        }
    }
    $settings['modules']['contentSource']['sourceClass'] = 'FileSystemContentSource';
}

//$settings['modules']['contentSource']['homePage'] = ask('Portal startpage, eg. /Content.Node/index.html:');

//memcached
if (prompt('Will you use memcached as caching system (recommended, is necessary for session)?')) {
    $settings['components']['cache']['servers']['server1'] = array('host' => '127.0.0.1', 'port' => 11211, 'weight' => 60);
}

//eauth
$settings['components']['eauth']['services']['standard'] = array(
    'title' => 'Use default login with username and password?'
);
if (prompt('Google authentication?')) {
    $settings['components']['eauth']['services']['google'] = array(
        'class' => 'site.common.modules.user.services.GoogleService',
        'title' => 'Use login with Google Open ID?'
    );
}

if (prompt('Facebook Authentication (you need a Facebook App)?')) {
    $settings['components']['eauth']['services']['facebook'] = array(
        'title' => 'Use login with Facebook?',
        'class' => 'site.common.modules.user.services.FacebookService',
    );
}

file_put_contents(CLIENT_CONFIG_LOCATION, '<?php return ' . var_export(CMap::mergeArray($ClientMainConfiguration, $settings), true) . ' ; ?>');

write('Configuration finished! Settings are in file ' . realpath(CLIENT_CONFIG_LOCATION));

// update the client_console.php-file
$myOldConsole = include '../custom/config/client_console.php';
file_put_contents('../custom/config/client_console.php', '<?php Yii::setPathOfAlias(\'site\', dirname(__FILE__) . DIRECTORY_SEPARATOR . \'..\' . DIRECTORY_SEPARATOR . \'..\'); return ' .
    var_export(CMap::mergeArray($myOldConsole, array('components' => array('db' => $settings['components']['db']))), true) . ' ; ?>');

function write($text)
{
    fwrite(STDOUT, $text . "\n");
}

function prompt($question)
{
    $answer = ask("\n" . $question . "\n[y|n]");
    if (yes($answer))
        return true;
    elseif (no($answer)) {
        return false;
    } else {
        return prompt($question);
    }
}

function ask($text)
{
    fwrite(STDOUT, $text . "\n");
    return trim(fgets(STDIN));
}

function yes($string)
{
    return substr($string, 0, 1) == 'y';
}

function no($string)
{
    return substr($string, 0, 1) == 'n';
}

