@ECHO OFF

:: for windows only
:APP_FOLDER
set /p applicationFolder=Specify path to the web application directory of your GPN PHP installation (no trailing slash):
if exist %applicationFolder%\frontend\www\index.php (
	echo 'Application directory is correct'
) else (
	echo 'Application directory is wrong. Please try again.'
	goto APP_FOLDER
)

::backup
:BACKUP
set /p backup=Make a backup of GPN PHP (y|n)?
if %backup%==y (
	:BACKUP_FOLDER
	set /p backupFolder=Set backup folder:
	if exist %backupFolder% (
		echo 'Backup folder is correct'
		rmdir /S %backupFolder%\gportal_backup
		mkdir %backupFolder%\gportal_backup
		xcopy %applicationFolder% %backupFolder%\gportal_backup /q /s /e /h

		set /p mysqlFolder=Set mysqldump folder:
		if exist %mysqlFolder% (
            %mysqlFolder%\mysqldump.exe --opt -–user=root --host=localhost -p gportal > %backupFolder%\gportal_backup\mysql\database.sql
		)

		echo You can find backup in the directory: %backupFolder%\gportal_backup
	) else (
		echo 'Backup folder is not correct. Please try again.'
		goto BACKUP_FOLDER
	)
) else (
	if %backup%==n (
		echo No backup done
	) else (
		goto :BACKUP
	)
)

:UPDATE
::backup www
rmdir %applicationFolder%\gpn_www_orig
xcopy %applicationFolder%\frontend\www %applicationFolder%\gpn_www_orig /q /s /e /h

for /f "delims=|" %%f in ('dir /b %updateFolder%') do (
	if %%f NEQ custom (
		echo %updateFolder%\%%f
		if exist %applicationFolder%\%%f (			
			rmdir /s /q %applicationFolder%\%%f		
		)
		xcopy %updateFolder%\%%f %applicationFolder%\%%f /q /i /s /e /h /y
	)	
)
::restore www
rmdir %applicationFolder%\frontend\www
xcopy %applicationFolder%\gpn_www_orig %applicationFolder%\frontend /q /s /e /h
rmdir %applicationFolder%\gpn_www_orig

if not exists %applicationFolder%\common\runtime ( mkdir %applicationFolder%\common\runtime )
if not exists %applicationFolder%\custom\runtime ( mkdir %applicationFolder%\custom\runtime )
if not exists %applicationFolder%\tests\runtime ( mkdir %applicationFolder%\tests\runtime )
if not exists %applicationFolder%\frontend\runtime ( mkdir %applicationFolder%\frontend\runtime )
if not exists %applicationFolder%\frontend\www\assets ( mkdir %applicationFolder%\frontend\www\assets )

::run migrations
%applicationFolder%\common\yiic.bat migrate --interactive=0

:REMOVE
set /p remove="For security reasons we should delete the installation script. Do you want to delete it now? (y|n)":
if %remove%==y (
	del %CD%\scripts\%0
	del %CD%\scripts\update.sh
	del %CD%\scripts\install.sh
	del %CD%\scripts\install.bat
) else (
	if %remove%==n (
		echo Update finished!
	) else (
		goto :REMOVE
	)
)


